from PIL import Image
import cv2

чёрный = 0, 0, 0
белый = 255, 255, 255
красный = 255, 0, 0
синий = 0, 0, 255
жёлтый = 255, 255, 0
зелёный = 0, 128, 0
коричневый = 75, 57, 37
голубой = 0, 191, 255
светлоголубой = 135, 206, 250

дальше = "дальше"
вниз = "вниз"
наискось_вниз = "наискось_вниз"
наискось_вверх = "наискось_вверх"

полупрозрачный = 112
прозрачный = 0
на80 = 180
на60 = 135
на40 = 90
на20 = 45
непрозрачный = 255

в2раза= 200
в5раз = 500
в10раз = 1000
в50раз = 5000
в100раз = 10000
в200раз = 20000
в500раз = 50000
в1000раз = 100000

def создать_холст(ширина, высота, цвет, прозрачность=225):
    return Image.new("RGBA", (ширина, высота), (*цвет, прозрачность))

def красить_пиксель(холст, x, y, цвет, прозрачность=225):
    холст.putpixel((x, y), (*цвет, прозрачность))

def перейти_вперёд(x, y, шаг):
    return x + шаг, y

def перейти_вниз(x, y, шаг):
    return x, y + шаг

def перейти_наискось_вниз(x, y, шаг):
    return x + шаг, y + шаг

def перейти_наискось_вверх(x, y, шаг):
    return x + шаг, y - шаг

def идти_дальше(x, y, шаг):
    return x + шаг, y
    
def сохранить(холст, размер=100):

    холст.save("result.png")

    img = cv2.imread("result.png")

    if img is None:
        print(f"Unable to load image from {'result.png'}")
        return None

    width = int(img.shape[1] * размер / 100)
    height = int(img.shape[0] * размер / 100)
    dim = (width, height)

    resized_img = cv2.resize(img, dim, interpolation=cv2.INTER_AREA)
    cv2.imwrite('result.png', resized_img)

def повторить(холст, раз = 1, координата1 = 0, координата2 = 0, куда = дальше, цвет = чёрный, прозрачность = 225, шаг=1):
    if куда == дальше:
        for _ in range(раз):
            красить_пиксель(холст, координата1, координата2, цвет, прозрачность)
            координата1, координата2 = перейти_вперёд(координата1, координата2, шаг)
    elif куда == вниз:
        for _ in range(раз):
            красить_пиксель(холст, координата1, координата2, цвет, прозрачность)
            координата1, координата2 = перейти_вниз(координата1, координата2, шаг)
    elif куда == наискось_вниз:
        for _ in range(раз):
            красить_пиксель(холст, координата1, координата2, цвет, прозрачность)
            координата1, координата2 = перейти_наискось_вниз(координата1, координата2, шаг)
    else:
        for _ in range(раз):
            красить_пиксель(холст, координата1, координата2, цвет, прозрачность)
            координата1, координата2 = перейти_наискось_вверх(координата1, координата2, шаг)